#include <TinyGPS++.h>
#define TINY_GSM_MODEM_SIM800
#include <TinyGsmClient.h>
#include <SoftwareSerial.h>


//----------------Gps----------------------->
String serial_number = "XSDG";
String lat, lng, speed, altitude, postdata,deg;
static const int RXPinGPS = 4, TXPinGPS = 3;
TinyGPSPlus gps;
SoftwareSerial SerialGPS(RXPinGPS, TXPinGPS);
//------------------------------------------>

//-----------------GSM---------------------->
String apn = "GPRS"; //APN
String apn_u = "";//APN-Username
String apn_p = "";//APN-Password
String url = "http://hamid-h.ir/gpsdata?tmpl=component";  //URL of Server
String payload;
SoftwareSerial SWserial(10, 11); // RX, TX
//------------------------------------------>


void setup(){
  serial_number = String("&serial_number="+serial_number);
  lat = String("&lat=");
  lng = String("&lng=");
  speed = String("&speed=");
  altitude = String("&altitude=");
  deg = String("&deg=");

  Serial.begin(115200);
  Serial.println("Start Program");
  SWserial.begin(9600);
  SerialGPS.begin(9600);

  delay(5000);
  while (SWserial.available()) {
    Serial.write(SWserial.read());
  }
  delay(2000);
  gsm_config_gprs();
}

void loop() {
  SerialGPS.listen();
  while (SerialGPS.available() > 0) {
    if (gps.encode(SerialGPS.read())) {
      Serial.println("Found true GPS position.");
      getGPSAndSend();
    }
  }
  if (millis() > 5000 && gps.charsProcessed() < 10){
    Serial.println(F("No GPS detected: check wiring."));
    while (true);
  }
}

void gsm_config_gprs() {
    Serial.println(" --- CONFIG GPRS --- ");
    gsm_send_serial("AT+SAPBR=3,1,Contype,GPRS");
    gsm_send_serial("AT+SAPBR=3,1,APN," + apn);
    gsm_send_serial("AT+SAPBR=1,1");
    gsm_send_serial("AT+SAPBR=2,1");  
    gsm_send_serial("AT+HTTPINIT");
    gsm_send_serial("AT+HTTPPARA=CID,1");
    gsm_send_serial("AT+HTTPPARA=URL," + url);
    gsm_send_serial("AT+HTTPPARA=CONTENT,application/x-www-form-urlencoded");  
}

void getGPSAndSend() {
  Serial.print(F("Location: "));
  if (gps.location.isValid()){
    /*
    String locationString = "&lat=" + String(gps.location.lat(),6) + "&lng=" + String(gps.location.lng(),6) + "&altitude=" + String(gps.altitude.meters())+ "&deg=" + String(gps.course.deg()) + "&speed=" + String(gps.speed.kmph());
    Serial.print("Trying to send data to Server: ");
    Serial.println(locationString);
    */
    lng=lng+String(gps.location.lng(),6);
    lat=lat+String(gps.location.lat(),6);
    speed=speed+(gps.speed.kmph());
    altitude=altitude+String(gps.altitude.meters());
    deg=deg+String(gps.course.deg());

    postdata = serial_number+lng+lat+speed+altitude+deg;
    gsm_http_post(postdata);
    
    lng="&lng=";
    lat="&lat=";
    speed="&speed=";
    altitude="&altitude=";
    deg="&deg=";
  }
  else
  {
    Serial.print("Invalid GPS position...");
  }
}



void gsm_http_post( String postdata) {
  Serial.println(" --- Start GPRS & HTTP --- ");
  gsm_send_serial("AT+HTTPPARA=CID,1");
  gsm_send_serial("AT+HTTPDATA=192,5000");
  gsm_send_serial(postdata);
  gsm_send_serial("AT+HTTPACTION=1");
  gsm_send_serial("AT+HTTPREAD");
  //gsm_send_serial("AT+HTTPTERM");
  //gsm_send_serial("AT+SAPBR=0,1");
}


void gsm_send_serial(String command) {
  Serial.println("Send ->: " + command);
  SWserial.println(command);
  long wtimer = millis();
  while (wtimer + 1000 > millis()) {
    while (SWserial.available()) {
      Serial.write(SWserial.read());
    }
  }
  Serial.println();
}
