#include <TinyGPS++.h>
#include <SoftwareSerial.h>
String serial,lat,lng,vspeed,elevation,postdata;
String apn = "APN";                    //APN
String apn_u = "";                     //APN-Username
String apn_p = "";                     //APN-Password
String url = "http://hamid-h.ir/gpsdata?tmpl=component";  //URL of Server


TinyGPSPlus gps;

SoftwareSerial SWserial(10, 11); // RX, TX
SoftwareSerial GPSserial(3, 4);// RX, TX

void setup()
{
  serial=String("serial=MDFS");
  lat = String("&lat=");
  lng = String("&lng=");
  vspeed = String("&vspeed=");
  elevation = String("&elevation=");
  Serial.begin(115200);
  Serial.println("SIM800 AT CMD Test");
  SWserial.begin(9600);
  GPSserial.begin(74880);
  //GPSserial.begin(9600);
  delay(5000);
  while (SWserial.available()) {
    Serial.write(SWserial.read());
  }
  delay(2000);
  gsm_config_gprs();
}

void loop() {
  
  
  // This sketch displays information every time a new sentence is correctly encoded.
  while (GPSserial.available() > 0)
    if (gps.encode(GPSserial.read()))
    Serial.print(gps.location.lat(), 6);  
   lat= lat + gps.location.lat();
   lng= lng + gps.location.lng();
   vspeed= vspeed + gps.speed.kmph();
   elevation=elevation + gps.altitude.meters();
   postdata=serial + lat + lng + vspeed + elevation;
   gsm_http_post(postdata);
   lat="&lat=";   
   lng="&lng=";
   vspeed="&vspeed=";
   elevation="&elevation=";
}

void gsm_http_post( String postdata) {
  Serial.println(" --- Start GPRS & HTTP --- ");
  gsm_send_serial("AT+SAPBR=1,1");
  gsm_send_serial("AT+SAPBR=2,1");
  gsm_send_serial("AT+HTTPINIT");
  gsm_send_serial("AT+HTTPPARA=CID,1");
  gsm_send_serial("AT+HTTPPARA=URL," + url);
  gsm_send_serial("AT+HTTPPARA=CONTENT,application/x-www-form-urlencoded");
  gsm_send_serial("AT+HTTPDATA=192,5000");
  gsm_send_serial(postdata);
  gsm_send_serial("AT+HTTPACTION=1");
  gsm_send_serial("AT+HTTPREAD");
  gsm_send_serial("AT+HTTPTERM");
  gsm_send_serial("AT+SAPBR=0,1");
}

void gsm_config_gprs() {
  Serial.println(" --- CONFIG GPRS --- ");
  gsm_send_serial("AT+SAPBR=3,1,Contype,GPRS");
  gsm_send_serial("AT+SAPBR=3,1,APN," + apn);
  if (apn_u != "") {
    gsm_send_serial("AT+SAPBR=3,1,USER," + apn_u);
  }
  if (apn_p != "") {
    gsm_send_serial("AT+SAPBR=3,1,PWD," + apn_p);
  }
}

void gsm_send_serial(String command) {
  Serial.println("Send ->: " + command);
  SWserial.println(command);
  long wtimer = millis();
  while (wtimer + 3000 > millis()) {
    while (SWserial.available()) {
      Serial.write(SWserial.read());
    }
  }
  Serial.println();
}
