// Program: Arduino control by SMS with SIM800L 
// Author: Milad Nemati www.epd4u.ir

#include <Sim800l.h> 
#include <SoftwareSerial.h>

Sim800l Sim800l;
String textSms;
String numberSms;
uint8_t LED1 = 4 ; // Connection Red Led 
uint8_t LED2 = 5 ; // Connection Green LED 
bool error;

void setup ()
{
  Serial.begin ( 9600 );
  pinMode (LED1, OUTPUT);
  pinMode (LED2, OUTPUT);

  Sim800l.begin ();
  Serial.print ( "Clearing old SMS ..." );
  error = Sim800l.delAllSms (); // Delete SMS 
  Serial.println ( "Off!" );
  Serial.println ( "\nSaving SMS commands ..." );
}

void loop ()
{
  // 
  textSms = Sim800l.readSms ( 1 );

  // Checks if SMS has been received and is valid 
  if (textSms.indexOf ( "OK" )!= - 1 )
  {
    // Checks if SMS is empty 
    if (textSms.length ()> 7 )
    {
      // Returns the number of the cell that sent the SMS 
      numberSms = Sim800l.getNumberSms ( 1 );
      // Displays the phone number in the Serial Monitor
      Serial.println (numberSms);
      // Converts text to uppercase
      textSms.toUpperCase ();


      // If you receive L1, the led 1 
        if (textSms.indexOf ( "L1" )!=- 1 )
      {
        Serial.println ( "Led 1 On" );
        digitalWrite (LED1, 1 );
       }
      // If D1 is received, turn off led 1  
      else  if (textSms.indexOf ( "D1" )!=- 1 )
      {
        Serial.println ( "Led 1 Off" );
        digitalWrite (LED1, 0 );
      }
      // If L2 is received, LED 2 will light up 
      else  if (textSms.indexOf ( "L2" )!=- 1 )
      {
        Serial.println ( "Led 2 On" );
        digitalWrite (LED2, 1 );

      }
      
      // If D2 is received, turn off led 2  
      else  if (textSms.indexOf ( "D2" )!=- 1 )
      {
        Serial.println ( "Led 2 Off" );
        digitalWrite (LED2, 0 );
      }
     
      // Delete all messages from the memory, ensuring that the next 
      // SMS is always in position 1
      Sim800l.delAllSms ();
    
  }
}
}
